<?php

@include_once dirname(__FILE__) . '/controls.php';

$plugin = $file_commerce_pro;

// If there is no action requested...
if (!$controls->is_action()) {
    // Nothing
}
else {
    // Process known actions. Some actions need to process the options, do something
    // without storing them on the database but showing them to the user a second time.
    if ($controls->is_action('save')) {
        $controls->options = stripslashes_deep($_POST['options']);
        $plugin->set_options($controls->options, 'mailing');
    }

    if ($controls->is_action('send')) {
        $controls->options = stripslashes_deep($_POST['options']);
        $plugin->set_options($controls->options, 'mailing');


        $users = $wpdb->get_results("select id, user_email as email from " . $wpdb->users);
        $file_id = $controls->options['file'];

        if (isset($mailer)) $mailer->set(1, 'file-commerce-pro');

        $controls->messages = 'Sent to: ';
        $count = 0;
        foreach ($users as $u) {
            if (!empty($file_id)) {
                // The order by id desc grants to get the latest *valid* (even if expired) contract. Refunded or non valid *contracts*
                // are ignored.
                $contract = $wpdb->get_row("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS .
                        " where userid=" . $u->id . " and fileid=" . $file_id . " and status=" . FileCommercePro::CONTRACT_VALID .
                        " order by id desc");

                if (empty($contract)) continue;
                // Is expired?
                if ($controls->options['status'] == 'expired' && $contract->expire > time()) continue;
                if ($controls->options['status'] == 'notexpired' && $contract->expire < time()) continue;
            }

            $controls->messages .= $u->email;
            
            $r = $plugin->mail($u->email, $controls->options['email_subject'], $controls->options['email_body']);
            //$r = $plugin->mail('satollo@gmail.com', $controls->options['email_subject'], $controls->options['email_body'], $headers);
            if ($r) $controls->messages .= ' [ok], ';
            else $controls->messages .= ' [ko], ';

            //$count++;
            //if ($count == 10) break;
        }
        $controls->messages .= 'end.';
        $plugin->admin_mail($controls->options['email_subject'], "*** COPY ***\n\n" . $controls->options['email_body']);
        if (isset($mailer)) $mailer->reset();
    }
}

if ($controls->options == null) $controls->options = $plugin->get_options('mailing');
?>

<div class="wrap">
    <h2><?php echo $plugin->title; ?>: Mailing</h2>

    <?php $controls->show_errors(); ?>
    <?php $controls->show_messages(); ?>

    <p>
        On this panel you can send emails to your customers with a number of filters to
        select them by product, status and so on. There is no email archive. Emails are sent
        at once: if you have a lot of customers, use a mail throttling plugin like
        <a href="http://www.satollo.net/plugins/mailer" target="_blank">Mailer</a>.
    </p>

    <form method="post" action="">
        <?php $controls->init(); ?>

        <table class="form-table">
            <tr valign="top">
                <th>Email<br /><small>Subject and message</small></th>
                <td>
                    <?php $controls->text('email_subject', 70); ?><br />
                    <?php $controls->textarea('email_body'); ?><br />
                </td>
            </tr>
            <tr valign="top">
                <th>To</th>
                <td>
                    who bought the file <?php $controls->select_files('file'); ?> and the contract is
                    <?php $controls->select('status', array('any'=>'Any', 'notexpired'=>'Not expired', 'expired'=>'Expired')); ?>
                    <?php //$controls->select('status', array('any'=>'Any', 'notexpired'=>'Not expired', 'expired'=>'Expired', 'expirein'=>'Will expire in')); ?>
                    <div class="hints">
                        Invalid contracts, for example after a refund, are not considered. The last valid contract is considered to evaluated
                        the status for customer that have more then one contract on a file.
                    </div>
                </td>
            </tr>
        </table>
        <p class="submit">
            <?php $controls->button('save', 'Save'); ?>
            <?php $controls->button('send', 'Send', 'Really send?'); ?>
        </p>
        
    </form>

</div>