<?php

// This page is for edit the main options

@include_once dirname(__FILE__) . '/controls.php';

$plugin = $file_commerce_pro;

if (!$controls->is_action()) {
    // Nothing
}
else {
    // Process known actions. Some actions need to process the options, do something
    // without storing them on the database but showing them to the user a second time.
    if ($controls->is_action('save')) {
        $plugin->set_options(stripslashes_deep($_POST['options']));
    }

    if ($controls->is_action('create_thankyou')) {
        $options = stripslashes_deep($_POST['options']);
        $default_options = $file_commerce_pro->get_default_options();
        $options['thankyou'] = $default_options['thankyou'];
        
        $plugin->set_options($options);
    }
    
    if ($controls->is_action('reset_new_user')) {
        $options = stripslashes_deep($_POST['options']);
        $default_options = $file_commerce_pro->get_default_options();
        $options['new_user_subject'] = $default_options['new_user_subject'];
        $options['new_user_body'] = $default_options['new_user_body'];
        
        $plugin->set_options($options);
    }    
    
    if ($controls->is_action('reset_notify_ok_body')) {
        $options = stripslashes_deep($_POST['options']);
        $default_options = $file_commerce_pro->get_default_options();
        $options['notify_ok_body'] = $default_options['notify_ok_body'];
        
        $plugin->set_options($options);
    }      
    
    if ($controls->is_action('sender_reset')) {
        $options = stripslashes_deep($_POST['options']);
        $default_options = $file_commerce_pro->get_default_options();
        $options['sender_email'] = $default_options['sender_email'];
        $options['sender_name'] = $default_options['sender_name'];
        
        $plugin->set_options($options);
    }    

    if ($controls->is_action('reset')) {
        $plugin->set_options(array_merge(stripslashes_deep($_POST['options']), $plugin->get_default_options()));
    }

     if ($controls->is_action('create')) {
        $page = array();
        $page['post_title'] = 'Downloads';
        $page['post_content'] = '[file_commerce_pro type="download"]';
        $page['post_status'] = 'publish';
        $page['post_type'] = 'page';
        $page['comment_status'] = 'closed';
        $page['ping_status'] = 'closed';
        $page['post_category'] = array(1);

        // Insert the post into the database
        $page_id = wp_insert_post($page);
        $controls->options = $plugin->get_options();
        $controls->options['main_url'] = get_permalink($page_id);
        $plugin->set_options($controls->options);
     }

     if ($controls->is_action('create_thankyou')) {
        $page = array();
        $page['post_title'] = 'Thank you';
        $page['post_content'] = 
'Thank you for your purchase it has been successfully recorded!
    
<strong>Kindly read the instruction below to get access to your product</strong>.

In <strong>few minutes</strong> a confirmation email will be sent to your email address with details to download the product. 
<strong>Please check the spam folder too</strong>, sometime emails are wrongly classified as unsolicited messages.

If you paid with <strong>eCheck</strong> or other non-instant payment methods the confirmation email will be sent as soon as the payment gateway send us the completed transaction notification.
<strong>It can take few days</strong>.

<strong>Payment notes</strong>

If you paid with Click Bank, your credit card will report ClickBank or CLKBANK*COM not the product name. It\'s ok. and it\'s the way Click Bank work.

The payment receipt will be sent to you by the payment gateway. 

<strong>Got problems or need to contact me?</strong>

For any problems with this purchase, please contact me at ' . get_option('admin_email') . '            
';
        $page['post_status'] = 'publish';
        $page['post_type'] = 'page';
        $page['comment_status'] = 'closed';
        $page['ping_status'] = 'closed';
        $page['post_category'] = array(1);

        // Insert the post into the database
        $page_id = wp_insert_post($page);
        $controls->options = $plugin->get_options();
        $controls->options['thankyou_url'] = get_permalink($page_id);
        $plugin->set_options($controls->options);
     }

     
    if ($controls->is_action('test_extend_contract')) {
        $controls->options = stripslashes_deep($_POST['options']);
        $contract = array();
        $contract['fileid'] = 1;
        $contract['userid'] = 1;
        $contract['status'] = FileCommercePro::CONTRACT_INVALID;
        $contract['gateway'] = FileCommercePro::GATEWAY_PAYPAL;
        $contract['txnid'] = 'TNXEXAMPLE';
        $contract['name'] = 'Cutomer name';
        $contract['email'] = 'customer@email.com';
        eval($controls->options['extend_contract']);

        $controls->messages = print_r($contract, true);
    }
}

if ($controls->options == null) $controls->options = $plugin->get_options();

if (empty($controls->options['main_url'])) {
    $controls->errors .= 'A download page should be created for a better user purchase and download experience.<br />';
}

if (empty($controls->options['thankyou']) && empty($controls->options['thankyou_url'])) {
    $controls->errors .= 'A thank you message or a thank you page address must be set in order to have File Commerce Pro working correctly.<br />';
}

if (!get_option('users_can_register') && $controls->options['login'] == 1) { 
    $controls->messages .= 'Warning! Users cannot register on your blog, enable that option on WordPress main settings if you do not want to
            use the account auto provisioning.<br />';
}
?>
<script>
var tabs;
jQuery(document).ready(function(){
    jQuery(function() {
        tabs = jQuery("#tabs").tabs({ cookie: { expires: 30 } });
    });    
});
</script>
<div class="wrap">

    <h2><?php echo $plugin->title; ?>: Main Configuration</h2>

    <?php $controls->show_errors(); ?>
    <?php $controls->show_messages(); ?>

    <p>
        Welcome to File Commerce Pro, the easiest way to sell your files! Take a look to all configurations available to
        setup your commerce.
    </p>


    <script>
        function file_commerce_pro_toggle() {
            var cookie = jQuery.cookie("fcp-main-hints");
            if (cookie === null) cookie = "1";
            cookie = "1" == cookie?"0":"1"
            jQuery(".hints").css("display", "1" == cookie?"block":"none");
            jQuery.cookie("fcp-main-hints", cookie);
        }
    </script>

    <form method="post" action="">
        <?php $controls->init(); ?>

        <a href="javascript:void(file_commerce_pro_toggle())">Show/hide hints under configuration field</a>

        <div id="tabs">

        <ul>
            <li><a href="#tabs-1">General configurations</a></li>
            <li><a href="#tabs-2">Payment gateways</a></li>
            <li><a href="#tabs-3">Messages</a></li>
            <li><a href="#tabs-7">Labels</a></li>
            <li><a href="#tabs-4">Support form</a></li>
            <li><a href="#tabs-5">Advanced</a></li>
            <li><a href="#tabs-6">Extend</a></li>
        </ul>
                        
        <div id="tabs-1">
        <table class="form-table">
            <tr valign="top">
                <th>Download page</th>
                <td>
                    <?php $controls->text('main_url', 70); ?>
                    <?php $controls->button('create', 'Create a page for me'); ?>
                    <div class="hints">
                        This is the address of a WordPress page where all files are listed so the user can download the accessible files
                        (because he bought them or because they are generally downloadable). It should be a standard page
                        with only the [file_commerce_pro] short code and an introductory text. 
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Thank you page<br /><small>(after a purchase)</small></th>
                <td>
                    <?php $controls->text('thankyou_url', 70); ?> <?php $controls->button('create_thankyou', 'Create a page for me'); ?>
                    <div class="hints">
                        This is the address of a WordPress page (you should hide it from menus) shown to the customer after a purchase.
                        Let File Commerce Pro to create one for you with the minimum required message.<br />
                        This is the preferred method.
                    </div>
                    
                    <br /><strong>- or a custom thank you message shown on a blank page (obsolete and deprecated) -</strong><br /><br />
                    <?php $controls->textarea('thankyou'); ?>
                    <?php $controls->button('create_thankyou', __('Create a message', 'filecommerce')); ?>
                    <div class="hints">
                        This message is shown to the customer right after a purchase on a blank boxed page.<br /> 
                        To test it <a target="_blank" href="<?php echo plugins_url('thankyou.php', __FILE__); ?>">click here</a>.
                    </div>
                </td>
            </tr>    
            
            <tr valign="top">
                <th>Email sender</th>
                <td>
                    email address: <?php $controls->text('sender_email', 30); ?>
                    name: <?php $controls->text('sender_name', 30); ?>
                    <?php $controls->button('sender_reset', 'Reset to safe values'); ?>
                    <div class="hints">
                        A number of notification emails can be sent by this plugin (newsletters, contract activation, contract expiration and so on).
                        All those emails will be sent with the sender data specified above. If those fields are left empty, WordPress default
                        email (wordpress@yourdomain.com) and name (your blog name) will be used.<br />
                        Setting those fields helps the receiver to better identify the email sender and eventually to reply to the specified address.<br />
                        Be aware that using an address not in the blog domain (like somename@gmail.com) can activate provider filters that will
                        block your emails (usually without notice).<br />
                    </div>
                </td>
            </tr>
            
            <tr valign="top">
                <th>Sign up message</th>
                <td>
                    <?php $controls->textarea('register_message'); ?>
                    <div class="hints">
                        <a href="<?php echo plugins_url('img/register_message.png', __FILE__); ?>" target="_blank"><img src="<?php echo plugins_url('img/register_message.png', __FILE__); ?>" height="100" hspace="15" align="right"/></a>
                        This message is shown under the sign up form, see the picture (click it to open a bigger version). On this message
                        you should explain that sign up is free and to use a primary email to be sure to receive the password. Do not forget to
                        remember the users to check the spam folder if they cannot find the email, that will saves you a lot of support requests.
                        <br clear="all"/>
                    </div>
                </td>
            </tr>

            <tr valign="top">
                <th>Pre registration and login/Register link text</th>
                <td>
                    <?php $controls->select('login', array(0=>'Login/registration is NOT required to buy', 1=>'Login/registration is required to buy')); ?><br />
                    <?php $controls->text('login_label', 70); ?>
                    <div class="hints">
                        When a non logged in user visit the file list and the login is required to buy, near each file there will be a link
                        inviting the user to login or register for free. This is the text of that link. If you
                        would use a graphical button, use HTML like:<br />
                        <code>&lt;img src="..." alt="Login or register free"/&gt;</code>
                    </div>
                </td>
            </tr>

            <!--
            <tr valign="top">
                <th>Thank you message</th>
                <td>
                    <?php $controls->textarea('thank_you'); ?>
                    <div class="hints">
                        This message is shown to customers after they buy a file on the file list page.<br />
                        Some payments require time to be registered and notified to File Commerce Pro
                        (for example when users pay with eCheck) so add a note about that asking the user to wait some
                        time if the file is not immediately available (and to avoid to pay twice...).
                    </div>
                </td>
            </tr>
            -->
            <!--
            <tr valign="top">
                <th>Contracts per file</th>
                <td>
                    <?php $controls->select('contract', array('single'=>'Only one', 'multi'=>'More than one')); ?>
                    <div class="hints">
                        This option enable customer to buy more than one copy of a file. This is useful when
                        customers are consultants and want to buy a copy for they clients.
                    </div>
                </td>
            </tr>
            -->
        </table>
        </div>

        <div id="tabs-2">
        <table class="form-table">
            <tr valign="top">
                <th>Click Bank</th>
                <td>                	
                    Vendor code: <?php $controls->text('clickbank_vendor_code', 30); ?>
                    Secret key: <?php $controls->text('clickbank_secret_key', 30); ?>
                    <br />
                    Instant notification URL: <?php echo plugins_url('clickbank.php', __FILE__); ?>
                    <br />
                    Thank you page: <?php echo plugins_url('thankyou.php', __FILE__); ?>
                    <br />
                    button label: <?php $controls->text('clickbank_button', 30); ?>
                    <div class="hints">
                        If the button label is left empty, a standard image button is used. The label can be a text or some
                        HTML code that will be surrounded with a link.
                    </div>
                    
                </td>
            </tr>

            <tr valign="top">
                <th>
                    PayPal
                </th>
                <td>
                    PayPal email: <?php $controls->text('paypal_email', 50); ?><br />
                    PayPal IPN (see user guide): <?php echo plugins_url('paypal.php', __FILE__); ?>
                    <div class="hints">
                        The email you, as merchant, use to log in into PayPal. This email is used to check the PayPal notifications,
                        it's really important!<br />
                        If you want to sell with more than one PayPal account write more than one email address separating them
                        with a space.
                    </div>
                    <br />
                    button label: <?php $controls->text('paypal_button', 30); ?>
                    <div class="hints">
                        If the button label is left empty, a standard image button is used. The label can be a text or some
                        HTML code that will be surrounded with a link.
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>
                    Plimus
                </th>
                <td>
                    <!--Secret key: <?php $controls->text('plimus_secret_key', 30); ?>
                    <br />-->
                    Instant notification URL: <?php echo plugins_url('plimus.php', __FILE__); ?>
                    <br />
                    Template redirect URL: <?php echo plugins_url('thankyou.php', __FILE__); ?>
                    <br />
                    button label: <?php $controls->text('plimus_button', 30); ?>
                    <div class="hints">
                        If the button label is left empty, a standard image button is used. The label can be a text or some
                        HTML code that will be surrounded with a link.
                    </div>
                    
                </td>
            </tr>
            <tr valign="top">
                <th>Buttons note</th>
                <td>
                    <?php $controls->textarea('buttons_note'); ?>
                    <div class="hints">
                        This text is shown under the payment button. Since some customers do not understand why
                        they are sent on a payment site which is totally different of your site, explain that you
                        are sending them on a SECURE payment gateway and then they will be redirected to your site.
                    </div>
                </td>
            </tr>
        </table>
        </div>
        
        <div id="tabs-3">
        <p>
            Here you set the emails to send to customers. Be sure to use the documented tags to customize the emails.
        </p>
        <table class="form-table">
            <tr valign="top">
                <th>New valid contract</th>
                <td>
                    <?php $controls->text('notify_ok_subject', 70); ?><br />
                    <?php $controls->textarea('notify_ok_body'); ?> 
                    <?php $controls->button('reset_notify_ok_body', 'Load a default message'); ?><br />
                    <div class="hints">
                        Email message sent on contract activation with file download details.                        
                        See the available tags below.
                    </div>
                </td>
            </tr>

            <tr valign="top">
                <th>Invalidated contract</th>
                <td>
                    <?php $controls->text('notify_ko_subject', 70); ?><br />
                    <?php $controls->textarea('notify_ko_body'); ?><br />
                </td>
            </tr>

            <tr valign="top">
                <th>New account message</th>
                <td>
                    <?php $controls->text('new_user_subject', 70); ?><br />
                    <?php $controls->textarea('new_user_body'); ?>
                    <?php $controls->button('reset_new_user', 'Reset'); ?>
                    <div class="hints">
                        New account creation message, with users credentials. Sent when a purchase is made
                        by a not logged in user.
                    </div>
                </td>
            </tr>

            <tr valign="top">
                <th>Tags</th>
                <td>
                    <div class="hints">
                        {user_id} - WordPress id of the customer<br />
                        {user_login} - the name the customer uses to log in<br />
                        {user_email} - the email of the customer<br />
                        {user_password} - the new user password (only on new user notifications)
                        {login_url} - the address the customer can follow to log in<br />
                        {login_url_download} - the log in url that redirects to the download page<br />
                        {file_title} - the title of the file of this notification<br />
                        {file_id} - the number of the file<br />
                        {file_url} - a direct download link without login<br />
                        {contract_expire} - the date of expiration of this contract<br />
                        {contract_id} - the number of the contract<br />
                        {contract_gateway} - the payment gateway used<br />
                        {contract_key} - a contract unique key (usually not used)<br />
                        {download_url} - the URL of the download page<br />
                        {password_url} - password recovery WordPress standard page
                    </div>
                </td>
            </tr>
        </table>
        </div>

         
        <div id="tabs-7">
        <p>
            Every label used by File Commerce Pro can be changed here.
        </p>
        <table class="form-table">
            <tr valign="top">
                <th>Download link text or purchased message</th>
                <td>
                    download label: <?php $controls->text('download_label', 70); ?><br />
                    purchased label: <?php $controls->text('purchased_label', 70); ?>
                    <div class="hints">
                        When you sell something which is not a real file to be downloaded (for example an installation or support service or
                        a membership), the "purchased label" will be shown, without a link.
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Contracts section</th>
                <td>
                    <?php $controls->text('contracts_label', 70); ?><br />
                    <div class="hints">
                        Text added on file list inside the area which lists the contracts expiration dates for the user.
                    </div>
                </td>
            </tr>
        </table>
        </div>

            
        <div id="tabs-4">
        <p>
            Use the short code [file_commerce_pro_support] on the page you want to use as support form. Before the short code
            give a brief explanation on how to use the form.<br />
            See the user guide for more tips on styling.
        </p>
        <table class="form-table">
            <tr valign="top">
                <th>Email</th>
                <td>
                    <?php $controls->text('support_email', 30); ?>
                    <div class="hints">
                        The email address where the support request are sent. Email comes from the user email address so you can
                        reply directly. On each file you can configure a different support email.
                    </div>
                </td>
            </tr>
            
            <tr valign="top">
                <th>Thank you messages</th>
                <td>
                    <?php $controls->textarea('support_ok'); ?>
                    <div class="hints">
                        Message shown when the support request is sent succesfully. Here you can say something about your response
                        timing. You can use HTML. 
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Login message</th>
                <td>
                    <?php $controls->textarea('support_login'); ?>
                    <div class="hints">
                        Message shown when the user is not logged in. Support form is available only to logged in
                        users. You can use HTML.<br />
                        If you want to offer a link to the login page, you can use:<br />
                        <code>&lt;a href="{login_url_back}"&gt;Login to send support requests&lt;/a&gt;</code><br />
                        where {login_url_back} (left as is) generate a special log in URL that, after log in, brings
                        back the user to the support page.
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Generic request</th>
                <td>
                    <?php $controls->select('support_generic', array(0=>'Disable generic request', 1=>'Enable generic request')); ?>
                    label: <?php $controls->text('support_generic_label'); ?>
                    <div class="hints">
                      Enable a "generic request" entry on support form for request not related to files. The label should be
                      somthing like "Generic request".
                    </div>
                </td>
            </tr>
            <!--
            <tr valign="top">
                <th>Access</th>
                <td>
                    <?php $controls->select('support_access', array('logged'=>'Only logged in users', 'all'=>'Every one')); ?>
                    <div class="hints">
                        The request is sent with customer data, so even if open to every one, you can distinguish butween customer
                        requests and anonymous request. For anonymous request and email address is asked to the user.<br />
                        Who send the request is asked to choose a product and the form will give evidence (to the user and to you)
                        about the status of that product for the user (see below the product list configuration).
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Products to show</th>
                <td>
                    <?php $controls->select('support_products', array('all'=>'All', 'active'=>'Only bought and still active')); ?>
                    <div class="hints">
                        When the user is asked to select a product, you can decide to list all of them or only the ones the customer
                        bought and are not expired (an expired contract is like the user never bought it).
                    </div>
                </td>
            </tr>
            -->
        </table>
        </div>

        <div id="tabs-5">
        <table class="form-table">
            <tr valign="top">
                <th>Styles or other codes</th>
                <td>
                    <?php $controls->textarea('style'); ?>
                    <div class="hints">
                        On text area below insert whatever you want to style the File Commerce Pro file list or
                        messages. Every thing you write will be added as is on the &lt;head&gt; section
                        of your blog. Styles are documented on file wp-content/file-commerce-pro/css/style.css.<br />
                        Remember to add the style tag:<br />
                        &lt;style&gt;<br />
                        your styles<br />
                        &lt;/style&gt;
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Logging</th>
                <td>
                    <?php $controls->select('log', array(0=>'Do not log', 1=>'Only errors', 2=>'Working activity', 3=>'Debug')); ?>
                    <div class="hints">
                        Log information are written on<br />
                        <code>wp-content/logs/file-commerce-pro-<?php echo $file_commerce_pro->secret; ?>.txt</code><br />
                        file. Note that "debug" log level
                        may save sensible data (even if hard to guess) is usually accessible to every one with a browser. Default value is
                        to log only errors.
                    </div>
                </td>
            </tr>
        </table>
        </div>


        <div id="tabs-6">
        <p>
            Use those configuration ONLY if you are a skilled PHP coder: any error here completely
            blocks File Commerce Pro! Read the User Guide for more information. No calims are accepted for 
            misusage of those really advanced configurations.
        </p>
        <table class="form-table">
            <tr valign="top">
                <th>Contract pre-insert manipulation</th>
                <td>
                    <?php $controls->textarea('extend_contract'); ?>
                    <?php $controls->button('test_extend_contract', 'Test'); ?>
                    <div class="hints">
                        This code is executed before add a new contract to the database. The contract is an associative array in the variable
                        <code>$contract</code>. With this code you can manipulate the content of the custom field <code>$contract['custom']</code>.
                    </div>
                </td>
            </tr>
            <tr>
                <th>Custom field display code</th>
                <td>
                    <?php $controls->textarea('extend_custom_display'); ?>
                    <div class="hints">
                        The contract is an object you can reference with <code>$contract</code>, 
                        the variable <code>$custom</code> contains the custom field value (the same as $contract->custom).
                    </div>
                </td>
            </tr>
            <tr>
                <th>Custom field display code for emails</th>
                <td>
                    <?php $controls->textarea('extend_custom_display_email'); ?>
                    <div class="hints">
                        The variable <code>$custom</code> contains the custom field value. The <code>$contract</code> variable can
                        be an object or an associative array, so pay attention (you can check it with <code>is_object($contract)</code>.
                    </div>
                </td>
            </tr>            
        </table>
        </div>
        
        </div><!-- tabs -->
        
        <p class="submit">
            <?php $controls->button('save', __('Save', 'filecommerce')); ?>
            <?php $controls->button('reset', __('Reset', 'filecommerce')); ?>
        </p>
        
    </form>
</div>
