<?php
/**
 * Questo è il "listener" per le chiamate server to server di Plimus e viene chiamato
 * direttamente.
 * 
 * TODO: aggiungere le notifica all'amministratore se qualcosa va male (vedi paypal.php).
 */

include '../../../wp-load.php';

function file_commerce_pro_plimus_verify() {
    global $file_commerce_pro;

    return true;
}

$file_commerce_pro->log_info('plimus.php');
$file_commerce_pro->log_debug($_GET);
$file_commerce_pro->log_debug($_POST);

$ok = false;
list($b1, $b2, $b3, $b4) = explode(',', $_SERVER['REMOTE_ADDR']);
if ($b1 == 62 && $b2 == 216 && $b3 == 234 && ($b4 >= 196 && $b4 <= 222)) $ok = true;
else if ($b1 == 72 && $b2 == 20 && $b3 == 107 && ($b4 >= 242 && $b4 <= 250)) $ok = true;
else if ($b1 == 209 && $b2 == 128 && $b3 == 93 && ($b4 >= 97 && $b4 <= 110)) $ok = true;
else if ($b1 == 209 && $b2 == 128 && $b3 == 93 && ($b4 >= 225 && $b4 <= 255)) $ok = true;

if (!ok) {
    $file_commerce_pro->log_error('Plimus IPN not from trusted IP: ' . $_SERVER['REMOTE_ADDR']);
    die();
}

if (!file_commerce_pro_plimus_verify()) {
    $file_commerce_pro->log_error('Plimus IPN unverified');
    die();
}

$file = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES . " where plimus=%s", $_POST['contractId']));

if (empty($file)) {
    $file_commerce_pro->log_error('File not found!');
    die();
}

// Prepare the ipn data
$ipn = array();
$ipn['gateway'] = FileCommercePro::GATEWAY_PLIMUS;
$ipn['data'] = serialize($_POST);
$ipn['request'] = serialize($_SERVER);
$ipn['created'] = time();

switch ($_POST['transactionType']) {
    case 'CHARGE':
    case 'RECURRING':
        $txnid = $_POST['referenceNumber'];
        $contract = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS . " where gateway='" . FileCommercePro::GATEWAY_PLIMUS . "' and txnid=%s", $txnid), ARRAY_A);

        if (!empty($contract) && $contract['status'] == FileCommercePro::CONTRACT_VALID) {
            $file_commerce_pro->log_error('Duplicated IPN, contract already in paid status');
            die();
        }

        // There is no contract for this transaction
        if (empty($contract)) {
            // No user associated, create a new account (plimus has not the custom)
            if (empty($_POST['custom'])) {
                $user = $file_commerce_pro->create_user($_POST['email']);
            }
            else
            {
                $user = get_user_by('id', $_POST['custom']);
            }

            $contract = array();
            $contract['fileid'] = $file->id;
            $contract['userid'] = $user->ID;
            $contract['status'] = FileCommercePro::CONTRACT_INVALID;
            $contract['gateway'] = FileCommercePro::GATEWAY_PLIMUS;
            $contract['txnid'] = $txnid;
            $contract['amount'] = 0;
            $contract['net_amount'] = 0;
            $contract['name'] = $_POST['firstName'] . ' ' . $_POST['lastName'];
            $contract['email'] = $_POST['email'];
            $contract['token'] = md5(time() . rand());

        }

        $contract['expire'] = $file_commerce_pro->get_contract_expiration_value($file->duration);
        $contract['status'] = FileCommercePro::CONTRACT_VALID;

        if (empty($contract['id'])) {
            $contract = apply_filters('file_commerce_pro_contract', $contract);
            $wpdb->insert($wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS, $contract);
            $contract['id'] = $wpdb->insert_id;
        }
        else {
            // Should not the case
            $id = $contract['id'];
            unset($contract['id']);
            $wpdb->update($wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS, $contract, array('id' => $id));
            $contract['id'] = $id;
        }

        $ipn['contractid'] = $contract['id'];
        $wpdb->insert($wpdb->prefix . FILECOMMERCEPRO_TABLE_IPN, $ipn);

        $file_commerce_pro->notify_new_contract($contract, $user);

        die();
        break;

    case 'CHARGEBACK':
    case 'REFUND':
        //$txnid = $_POST['parent_txn_id'];
        $contract = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS . " where gateway='" . FileCommercePro::GATEWAY_PLIMUS . "' and txnid=%s", $txnid), ARRAY_A);
        if (empty($contract)) {
            $file_commerce_pro->log_error('Contract not found.');
            $wpdb->insert($wpdb->prefix . FILECOMMERCEPRO_TABLE_IPN, $ipn);
            die();
        }

        $ipn['contractid'] = $contract['id'];
        $wpdb->insert($wpdb->prefix . FILECOMMERCEPRO_TABLE_IPN, $ipn);

        $wpdb->update($wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS, array('status' => FileCommercePro::CONTRACT_INVALID), array('id' => $contract['id']));
        $file_commerce_pro->notify_invalidated_contract($contract);
        die();
        break;

}
