<?php

@include_once(dirname(__FILE__) . '/commons.php');
@include_once(dirname(__FILE__) . '/controls.php');

$plugin = $file_commerce_pro;

// Process known actions. Some actions need to process the options, do something
// without storing them on the database but showing them to the user a second time.

if ($controls->is_action('activate'))
{
	$plugin->log_debug("Activating file with id ".$_POST['fileid']);
	if (file_commerce_pro_update_file_status($_POST['fileid'], 1))
	{
		$controls->errors = "File activated.";
	}
	else 
	{
		$plugin->log_error("Error during file update on database");
		$controls->errors = "Error during file update on database.";		
	}
}
elseif ($controls->is_action('deactivate'))
{
	$plugin->log_debug("Deactivating file with id ".$_POST['fileid']);
	$plugin->log_debug("Activating file with id ".$_POST['fileid']);
	if (file_commerce_pro_update_file_status($_POST['fileid'], 0))
	{
		$controls->errors = "File deactivated.";
	}
	else 
	{
		$plugin->log_error("Error during file update on database");
		$controls->errors = "Error during file update on database.";		
	}
}

if ($controls->options == null) $controls->options = $plugin->get_options();

?>

<div class="wrap">

    <h2><?php echo $plugin->title; ?>: File Management</h2>

    <?php $controls->show_errors(); ?>
    <?php $controls->show_messages(); ?>

    <p>
        Here you can manage the files you're selling. A file can be downloaded by a customer for the period
        you set on the file, so do not delete it if you have active customers on it! To make a new versions
        of a file available, simple edit it and upload a new version.
    </p>

			
	<div style="display:none">
		<form action="" method="post" id="filedelete">
			<?php $controls->init(); ?>
			<input type="hidden" name="act" value="delete" />
			<input type="hidden" name="fileid" id="fileid" />
		</form>
	</div>

	<div style="display:none">
		<form action="<?php echo file_commerce_pro_get_plugin_admin_url('repository_edit.php'); ?>" method="post" id="fileedit">
			<?php $controls->init(); ?>
			<input type="hidden" name="act" value="editreq" />
			<input type="hidden" name="fileid" id="fileeditid" />
		</form>
	</div>	

	<div style="display:none">
		<form action="" method="post" id="fileactivate">
			<?php $controls->init(); ?>
			<input type="hidden" name="act" value="activate" />
			<input type="hidden" name="fileid" id="fileactivateid" />
		</form>
	</div>
	
	<div style="display:none">
		<form action="" method="post" id="filedeactivate">
			<?php $controls->init(); ?>
			<input type="hidden" name="act" value="deactivate" />
			<input type="hidden" name="fileid" id="filedeactivateid" />
		</form>
	</div>
			

		<p>
                    <form action="?page=file-commerce-pro/repository_edit.php" method="post">
                        <?php $controls->init(); ?>
                        <?php $controls->button('new', 'Add a new file to sell'); ?>
                    </form>
                </p>

                <table class="widefat" style="width: auto">
			<thead>
                <tr>
                    <th>Actions</th>
                    <th>File "id"</th> 
                    <th>Title</th>
                    <th>Price</th>
                    <th>Hits</th>
                    <!--<th>Description</th>-->
                    <!--<th>File on disk</th>-->
                    <th>Active customers</th>
                    <th>Parents</th>
            	</tr>
            </thead>
		<?php
		$query = "select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES;
		$files = $wpdb->get_results($query);
                $txt = '';
                $i = 0;
		foreach ($files as &$file) 
		{
                    $i++;
                    // Computes the active customer for a file
                    $active_count = $wpdb->get_var("select count(*) from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_CONTRACTS .
                            " where fileid=" . $file->id . " and status=" . FileCommercePro::CONTRACT_VALID . " and expire>" . time());

			$txt = '<tr class="' . ($i%2?'alternate':'') . '">';
			$txt .= '<td><a href="admin.php?page=file-commerce-pro/repository_edit.php&amp;id=' . $file->id . '">edit</a></td>';
			$txt .= '<td>' . $file->id . '</td>';
			$txt .= '<td nowrap>' . $file->title . '</td>';
                        $txt .= '<td>' . $file->price . '</td>';
                        $txt .= '<td>' . $file->hits . '</td>';
			//$txt .= '<td>'.htmlspecialchars($file->description).'</td>';
                        //$txt .= '<td>'.htmlspecialchars($file->filename).'</td>';
                        $txt .= '<td>' . $active_count . '</td>';
                        $txt .= '<td>' . $file->parent_fileid . '</td>';
                        $txt .= '</tr>';
			echo $txt;
		}
		?>
		</table>


</div>