<?php

@include_once(dirname(__FILE__) . '/commons.php');
@include_once(dirname(__FILE__) . '/controls.php');


$plugin = $file_commerce_pro;

if (!$controls->is_action()) {
    $id = $_GET['id'];
    // Read from database in associative array format (ARRAY_A)
    $controls->options = $wpdb->get_row($wpdb->prepare("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES . " where id=%d", $id), ARRAY_A);
}
else {
    if ($controls->is_action('new')) {
        $controls->options = array(
            'title'=>'New file on sale',
            'status'=>FileCommercePro::FILE_DISABLED,
            'duration'=>365,
            'price'=>'100$'
            );
        $r = $wpdb->insert($wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES, $controls->options);
        $controls->options['id'] = $wpdb->insert_id;
        $controls->messages = 'New file created, fill in the file details and remember to change the status (actually "disabled")';
    }

    if ($controls->is_action('delete')) {
        $controls->options = stripslashes_deep($_POST['options']);
        $upload_dir = $plugin->get_wp_upload_dir_path() . '/' . FILECOMMERCEPRO_FILE_UPLOAD_DIR;
        if (!empty($controls->options['filename'])) @unlink($upload_dir . $controls->options['filename']);
        file_commerce_pro_delete_file_from_db($controls->options['id']);
        ?>
        <script>
            location.href = '<?php echo file_commerce_pro_get_plugin_admin_url('repository.php'); ?>';
        </script>
        <?php
        exit();
    }

    if ($controls->is_action('save'))
    {
        $controls->options = stripslashes_deep($_POST['options']);
        if (is_array($controls->options['parent_fileid'])) {
            $controls->options['parent_fileid'] = implode(',', $controls->options['parent_fileid']);
        }
        else {
            $controls->options['parent_fileid'] = '';
        }
        
        if (((int)$controls->options['duration']) == 0)
            $controls->errors = "Check the download duration.<br />";
        
        $upload_dir = $plugin->get_wp_upload_dir_path() . '/' . FILECOMMERCEPRO_FILE_UPLOAD_DIR;
        if (!wp_mkdir_p($upload_dir)) {
            $controls->errors = "Error creating upload dir: " . $upload_dir . ".<br />";
        }
        
        if (!empty($controls->options['support_email']) && !is_email($controls->options['support_email'])) {
            $controls->errors = 'The support email is not empty but wrong';
        }

        // Check if there is a file to replace the old one
        if ($controls->errors == null)
        {
            $old_filename = $wpdb->get_var($wpdb->prepare("select filename from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES . " where id=%d", $controls->options['id']));
            if (isset($_POST['remove_file'])) $controls->options['filename'] = '';
            else if ($_FILES['file']['size'] > 0) {

                if ($controls->errors == null)
                {
                    $controls->options['filename'] = md5(uniqid()) . '_' . file_commerce_pro_sanitize_filename($_FILES['file']['name']);
                    if (!move_uploaded_file($_FILES['file']['tmp_name'], $upload_dir . $controls->options['filename'])) {
                        $controls->errors = "Cannot save the uploaded file: " . $controls->options['filename'];
                    }
                }                
            }
        }

        if ($controls->errors == null) {
            $id = $controls->options['id'];
            unset($controls->options['id']);
            $r = $wpdb->update($wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES, $controls->options, array('id'=>$id));

            if ($r === false)
            {
                $controls->errors = "Error saving to database.";
                $plugin->log_error("Error saving to database");
            }
            else
            {
                if (!empty($old_filename) && $old_filename != $controls->options['filename']) @unlink($upload_dir . $old_filename);
                $controls->options = $wpdb->get_row("select * from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES . " where id=" . $id, ARRAY_A);
            }
        }
    }
}

if ($controls->errors != null) $controls->errors .= '<br /><strong>If you were uploading a new file, reselect it</strong>.';
?>
<script>
var tabs;
jQuery(document).ready(function(){
    jQuery('#upload-image').click(function() {
        tb_show('', 'media-upload.php?type=image&amp;TB_iframe=true');
        return false;
    });

    window.send_to_editor = function(html) {
        var imgurl = jQuery('img',html).attr('src');
        jQuery('#options_image').val(imgurl);
        jQuery('#options_image_img').attr('src', imgurl);
        tb_remove();
    }
    
    jQuery(function() {
        tabs = jQuery("#tabs").tabs({ cookie: { expires: 30 } });
    });    
});
</script>
<div class="wrap">

    <h2><?php echo $plugin->title; ?>: Create/Edit a File</h2>

    <?php $controls->show_errors(); ?>
    <?php $controls->show_messages(); ?>

    <p>
        Be aware that on title, price and description you can use HTML and it must be correct otherwise the file listing
        (both on site and on "Files" panel) can break. See the user guide for some interesting examples.
    </p>


        <form enctype="multipart/form-data" action="admin.php?page=file-commerce-pro/repository_edit.php" method="post">
            <?php $controls->init(); ?>
            <?php $controls->hidden('id'); ?>
            <?php $controls->hidden('filename'); ?>

            <div id="tabs">
                
            <ul>
                <li><a href="#tabs-1">File details</a></li>
                <li><a href="#tabs-2">Paypal</a></li>
                <li><a href="#tabs-3">Clickbank and Plimus</a></li>
                <li><a href="#tabs-4">Advanced</a></li>
            </ul>
            
            <div id="tabs-1">    
            <table class="form-table">
              <tr valign="top">
                <th>File identifier and status</th>
                <td>
                    <?php echo $controls->options['id']; ?>
                    <?php $controls->select('status', array(FileCommercePro::FILE_ON_SALE=>'On sale', 
                        FileCommercePro::FILE_ONLY_DOWNLOAD=>'Only for download to who have an active contract on this file',
                        FileCommercePro::FILE_FREE=>'Free for all',
                        FileCommercePro::FILE_FREE_REGISTERED=>'Free for registered users',
                        FileCommercePro::FILE_FREE_WITH_CONTRACT=>'Free for customers with at least one contract active',
                        FileCommercePro::FILE_DISABLED=>'Disabled')); ?>
                    
                    <div class="hints">
                        This value must be used on PayPal buttons to link them to this file. It is generated on first save.
                        See the user guide.
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Title</th>
                <td>
                    <?php $controls->text('title', 70); ?>
                    <div class="hints">
                        This is what describe the file to your customer. When you sell files which have a version
                        (for example a software) be sure to add the version information on this field.
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Description</th>
                <td>
                    <?php $controls->textarea('description', 70); ?>
                    <div class="hints">
                        That is an optional long description of your file. If you have different prices on different
                        payments method, describe it here.
                    </div>
                </td>
            </tr>            
            <tr valign="top">
                <th>Physical file to deliver</th>
                <td>
                    <input type="file" name="file" id="uploadedfile" />
                    <?php if (!empty($controls->options['filename'])) { ?>
                    <input type="checkbox" value="1" name="remove_file"/> Remove it
                    <?php } ?>
                    
                    (on disk: <?php echo $controls->options['filename']; ?>)
                    <br />
                    <b>- OR -</b>
                    <br />
                    the physical file of:
                    <?php $controls->select_files('linked_fileid', 'No one'); ?>
                    <div class="hints">
                        If you leave this empty, the already uploaded file will not be overwritten. If you choose to deliver the
                        physical file another file the customer must have purchased this file! It is useful to have only one
                        package to upload and to sell it under difference license conditions.
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Price description</th>
                <td>
                    <?php $controls->text('price', 70); ?>
                    <div class="hints">
                        This price is what is shown on file list and it should be coherent with price you set on
                        payment gateways. The price is textual, so you can write whatever you want and enrich it with HTML. See the user guide for
                        advanced examples and some tips.
                    </div>
                </td>
            </tr>   
            <tr valign="top">
                <th>Download granted for</th>
                <td>
                    <?php $controls->text('duration', 10); ?> (days)
                </td>
            </tr>   
            <tr valign="top">
                <th>Image</th>
                <td>
                    <?php $controls->text('image', 70); ?>
                    <input type="button" id="upload-image" value="Select/Upload an image"/>
                    <img alt="" id="options_image_img" src="<?php echo $controls->options['image']; ?>" height="75" align="right"/>
                </td>
            </tr>            
        </table>
            </div>
            
            <div id="tabs-2"> 
            <p>
                You can choose between connecting the file with a PayPal button or specifing a price and a currency (simpler). Price specification has
                priority. If you create complex PayPal buttons (and PayPal does not generated the button link for email, you must use the
                button form configuration copying the HTML snippet generated by PayPal (see the <a href="http://www.satollo.net/plugins/file-commerce" target="_blank">user guide</a>).
            </p>
            <p>
                The "buy now" link or PayPal using any of the methods below is:<br />
                <code><?php echo plugins_url('buy.php', __FILE__); ?>?g=paypal&amp;f=<?php echo $controls->options['id']; ?></code><br />
                (it does not change if you modify the PayPal parameters, so you can use it forever)
            </p>
        <table class="form-table">
            <tr valign="top">
                <th>Status</th>
                <td>
                    <?php $controls->select('paypal_enabled', array(0=>'Disabled', 1=>'Enabled')); ?>
                </td>
            </tr>                
            <tr valign="top">
                <th>Price and currency</th>
                <td>
                    <?php $controls->text('amount', 10); ?>
                    <?php $controls->select('currency', array('USD'=>'US Dollars', 'EUR'=>'Euro')); ?>
                    <div class="hints">
                        The price MUST have two decimal digit and the DOT as separator.<br />
                        5.95 or 5500.99 are correct<br />
                        7.9 or 7,90 or 1,000.50 are wrong
                    </div>
                </td>
            </tr>
            
            <tr valign="top">
                <th>or PayPal button code</th>
                <td>
                    <?php $controls->text('paypal', 30); ?>
                    <div class="hints">
                        The unique button identifier generated by PayPal (see the user guide).
                    </div>
                </td>
            </tr>
                    
            <tr valign="top">
                <th>or PayPal button form</th>
                <td>
                    <?php $controls->textarea('paypal_form'); ?>
                    <div class="hints">
                        The HTML snippet generated by PayPal for complex buttons (see the user guide).
                    </div>
                </td>
            </tr>
        </table>
            </div>
            
           
        
        <div id="tabs-3">    
            <h3>Plimus</h3>
            <table class="form-table">
            <tr valign="top">
                <th>Status</th>
                <td>
                    <?php $controls->select('plimus_enabled', array(0=>'Disabled', 1=>'Enabled')); ?>
                </td>
            </tr>                
            <tr valign="top">
                <th>Plimus contract code</th>
                <td>
                    <?php $controls->text('plimus', 30); ?>
                    <div class="hints">
                        Buy now link: <?php echo plugins_url('buy.php', __FILE__); ?>?g=plimus&amp;f=<?php echo $controls->options['id']; ?>
                    </div>
                </td>
            </tr>
            </table>
            
            
            <h3>Clickbank</h3>
            <table class="form-table">
            <tr valign="top">
                <th>Status</th>
                <td>
                    <?php $controls->select('clickbank_enabled', array(0=>'Disabled', 1=>'Enabled')); ?>
                </td>
            </tr>                
            
            <tr valign="top">
                <th>Item number</th>
                <td>
                    <?php $controls->text('clickbank', 30); ?>
                    <div class="hints">
                        This value must be equal to the product item number you assign on Clickbank admin pages.<br />
                        Buy now link: <?php echo plugins_url('buy.php', __FILE__); ?>?g=clickbank&amp;f=<?php echo $controls->options['id']; ?>
                    </div>
                </td>
            </tr>
            </table>
        </div>
            
                
                
        <div id="tabs-4">    
        <table class="form-table">            
            <tr valign="top">
                <th>Parent files</th>
                <td>
                    <div class="checkboxes">
                    <?
                        $ids = explode(',', $controls->options['parent_fileid']);
                        $files = $wpdb->get_results("select id, title from " . $wpdb->prefix . FILECOMMERCEPRO_TABLE_FILES . " order by title");

                        foreach($files as &$file)
                        {
                            echo '<div>';
                            echo '<input type="checkbox" name="options[parent_fileid][]" value="' . $file->id . '"';
                            if (array_search($file->id, $ids) !== false) echo ' checked';
                            echo '/>&nbsp;' . $file->title;
                            echo '</div>';
                        }
                    ?>
                    </div>
                    <div style="clear: both"></div>
                    <div class="hints">
                        If you check at least one parent file, this file is considered purchased if the customer has a valid
                        contract on one of the parent files. File Commerce Pro check first if there is a contract for this file and
                        then (if no valid contract can be found) if there is a contract on at least a parent file.
                    </div>
                </td>
            </tr>
            <tr>                
                <th>Order</th>
                <td>
                    <?php $controls->text('idx', 5); ?>
                    <div class="hints">
                        File list will be ordered by this number, from lower to higher.
                    </div>
                </td>
            </tr>
            <tr valign="top">
                <th>Product URL</th>
                <td>
                    <?php $controls->text('url', 50); ?>
                    <div class="hints">
                        Product title will be linked to this URL.
                    </div>
                </td>
            </tr> 
            
            <tr valign="top">
                <th>Support email</th>
                <td>
                    <?php $controls->text('support_email', 50); ?>
                    <div class="hints">
                        Support request are sent to this address to other than to main address configured on main panel.
                    </div>
                </td>
            </tr> 
            <!-- for future releases
            <tr valign="top">
                <th>Version</th>
                <td>
                    <?php $controls->text('version', 10); ?>
                    <div class="hints">
                    </div>
                </td>
            </tr>            
            -->
            <tr valign="top">
                <th>Alternative new purchase email</th>
                <td>
                    <?php $controls->text('notify_ok_subject', 70); ?><br />
                    <?php $controls->textarea('notify_ok_body'); ?>
                    <div class="hints">
                        An alternative email notification message when a new purchse ie registered. Can be useful for files who need special
                        instructions or files that has no a physical download.
                        <br />
                        Leave the subject empty to use the standard message. 
                    </div>
                </td>
            </tr>  
            <!--
            <tr valign="top">
                <th>Single or multi contract</th>
                <td>
                    <?php $controls->select('multicontract', array(0=>'Single contract', 1=>'Multi contract')); ?>
                    <div class="hints">
                        When "single contract" is used, a second payment create a new contract that extends the expiration time of 
                        the previous active contract if one. When "multi contract" is used, a new payment create a new independant contract (so two or more contracts can
                        have overlapping validity periods).
                    </div>
                </td>
            </tr>
            -->
        </table>
        </div>
                
        <!--/tabs-->    
        </div>    
        <p class="submit">
            <?php $controls->button('save', 'Save'); ?>
            <?php $controls->button('delete', 'Delete', 'Are you REALLY sure you want to delete this file?'); ?>
            <a href="<?php echo file_commerce_pro_get_plugin_admin_url('repository.php'); ?>" class="button">Return to file list</a>
        </p>
    </form>

</div>
