<?php

class FileCommerceProLoginWidget extends WP_Widget {

    function FileCommerceProLoginWidget() {
        parent::WP_Widget(false, $name = 'File Commerce Pro Login',
                        array('description' => 'File Commerce Pro Login box'),
                        array('width' => '350px'));
    }

    function widget($args, $instance) {
        global $file_commerce_pro;
        extract($args);

        echo $before_widget;
        if (!empty($instance['title'])) {
            echo $before_title . $instance['title'] . $after_title;
        }
                
        if (is_user_logged_in()) {
            echo '<a href="';
            echo wp_logout_url($_SERVER['REQUEST_URI']);
            echo '">';
            _e('Log Out');
            echo '</a>';
        }
        else {
            echo $instance['text'];
            echo '<form action="';
            echo wp_login_url($_SERVER['REQUEST_URI']);
            echo '" method="post">';
            _e('Username');
            echo ':<br /><input type="text" size="20" name="log"/><br />';
            _e('Password');
            echo ':<br /><input type="password" size="20" name="pwd"/><br />';
            echo '<input type="submit" value="';
            esc_attr_e('Log In');
            echo '" name="wp-submit">';
            echo '<input type="hidden" value="forever" name="rememberme"/>';
            echo '</form><br />';
            echo '<a href="' . site_url('wp-login.php?action=lostpassword', 'login') . '">';
            _e('Lost your password?');
            echo '</a>';   
        }            

        echo $after_widget;
    }

    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        $instance['text'] = $new_instance['text'];
        return $instance;
    }

    function form($instance) {
?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>">
                Title:
                <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($instance['title']); ?>" />
            </label>


            <label for="<?php echo $this->get_field_id('text'); ?>">
                Introduction:
                <textarea class="widefat" rows="10" cols="20" id="<?php echo $this->get_field_id('text'); ?>" name="<?php echo $this->get_field_name('text'); ?>"><?php echo esc_html($instance['text']); ?></textarea>
            </label>
        </p>
<?php
    }

}

add_action('widgets_init', create_function('', 'return register_widget("FileCommerceProLoginWidget");'));
?>
